function HVScroller(hax,h_handles,v_handles)
%     %ERIC's hack to toolbox\matlab\graph3d\rotate3d.m
%     s = get(hFig,'UserData');
%     if isa(s,'function_handle')
%       set(rdata,'KeyPressFcn',{s,rdata});
%     else
%       set(rdata,'KeyPressFcn',{@rotaKeyPressFcn,rdata});
%       set(rdata,'KeyReleaseFcn',{@locKeyReleaseFcn,rdata});
%     end

  hfig = get(hax,'Parent');
  set(hfig,'Toolbar','figure', ...      
           'HandleVisibility','on',...
           'KeyPressFcn',@keyPress); 
           
  hscroll.h = h_handles;
  hscroll.v = v_handles;
           
  hui.h = {0,0};
  if length(hscroll.h)>1  
    hui.h=createSlider(hax,length(hscroll.h),'h',@updateHData);  
  end  
  hui.v = {0,0};
  if length(hscroll.v)>1              
    hui.v=createSlider(hax,length(hscroll.v),'v',@updateVData);      
  end      

  [lasti.h,lasti.v] = deal(1);  
  for j = 2:length(hscroll.h)
    set(hscroll.h{j},'Visible','off');    
  end    
  for j = 2:length(hscroll.v)
    set(hscroll.v{j},'Visible','off');    
  end    
    
  set(hfig,'UserData',@keyPress);
  packData(hax,{hscroll,hui,lasti});
  
  
  function updateHData(hObject, eventdata, handles)   
    hax = getAxes(hObject);  
    [hscroll,hui,lasti] = unpackData(hax);

    i = round(get(hObject,'value'));
    set(hObject,'value',i);

    set(hscroll.h{lasti.h},'Visible','off');
    
    if strcmp(get(hscroll.h{i},'type'),'patch') 
      if ~isempty(get(hscroll.h{i},'faces'))
        set(hscroll.h{i},'Visible','on');
      end
    else
      set(hscroll.h{i},'Visible','on');
    end
    
    set(hui.h{2},'String', sprintf('%i/%i',i,length(hscroll.h)))
    
    udata = get(hscroll.h{i},'UserData');
    if ~isempty(udata) && ischar(udata)
       set(hui.h{3},'String', udata);
    end
    
    lasti.h = i;
    
    packData(hax,{hscroll,hui,lasti});
  end

  function updateVData(hObject, eventdata, handles) 
    hax = getAxes(hObject);  
    [hscroll,hui,lasti] = unpackData(hax);    
    
    i = round(get(hObject,'value'));
    set(hObject,'value',i);

    set(hscroll.v{lasti.v},'Visible','off');
    set(hscroll.v{i},'Visible','on');
    
    set(hui.h{2},'String', sprintf('%i/%i',i,length(hscroll.v)))
    
    lasti.v = i;
           
    packData(hax,{hscroll,hui,lasti});
  end

  function keyPress(hObject, eventdata, handles)
    hax = getAxes(hObject);
    [hscroll,hui,lasti] = unpackData(hax);    
    nH = length(hscroll.h);
    nV = length(hscroll.v);
    switch lower(eventdata.Key)
      case 'uparrow'
        if lasti.v<nV && hObject~=hui.h{1}
          set(hui.v{1},'value',lasti.v+1); 
          updateVData(hui.v{1},[],[]);
        end
      case 'downarrow'
        if lasti.v>1 && hObject~=hui.h{1}
          set(hui.v{1},'value',lasti.v-1);
          updateVData(hui.v{1},[],[]);
        end 
      case 'rightarrow'
        if lasti.h<nH && hObject~=hui.v{1}
          set(hui.h{1},'value',lasti.h+1); 
          updateHData(hui.h{1},[],[]);
        end
      case 'leftarrow'
        if lasti.h>1 && hObject~=hui.v{1}
          set(hui.h{1},'value',lasti.h-1);      
          updateHData(hui.h{1},[],[]);
        end      
      otherwise
        return
    end    
    packData(hax,{hscroll,hui,lasti});
  end


  function hax = getAxes(hObject)    
    hax = [];
    ch = get(hObject,'Children');
    for i=1:length(ch)
      if strcmp(get(ch(i),'type'),'axes')
        hax = ch(i);       
        return;
      end
    end
    hax = getAxes(get(hObject,'Parent'));
    if isempty(hax)    
      error('no axes on this figure!');
    end
  end

  function varargout = unpackData(hObject)    
    s = get(hObject,'UserData');
    t = s{1};
    if nargout ~= length(t)
      error('number of outputs must be %i',length(t)); 
    end    
    for i=1:length(t)
      varargout{i} = t{i};
    end    
  end

  function packData(hObject,varargin)
    nVars = nargin-1;
    for i=1:nVars
      s{i} = varargin{i};      
    end    
    set(hObject,'UserData',s);
  end

  function h = createSlider(hax,nsteps,orientation,callback)
    hfig = get(hax,'Parent');
    switch lower(orientation)
      case 'h'
        position = [.1 .005 .8 .025];
        countpos = [.9 .005 .1 .025];
        textpos  = [ 0 .005 .1 .025];
      case 'v'
        position = [.005 .1 .025 .8];
        countpos = [.005 .9 .025 .1];
        textpos  = [.005  0 .025 .1];
      otherwise 
        error('Unknown orientation passed in');
    end
    h{1} = uicontrol(hfig,'style','slider',...    
                'SliderStep',[1/(nsteps-1),2/(nsteps-1)],...
                'Units','normalized',...
                'Position', position,...
                'value',1,...
                'min',1,'max',nsteps,...
                'HandleVisibility','callback', ...
                'callback',callback,...
                'KeyPressFcn',@keyPress,...
                'UserData',{'axes',hax});   
    h{2} = uicontrol('Style', 'text',... 
                'String', sprintf('1/%i',nsteps),...
                'BackgroundColor',[.8 .8 .8],...
                'Units','normalized',...
                'Position', countpos);
    h{3} = uicontrol('Style', 'text',... 
                'String', '',...
                'BackgroundColor',[.8 .8 .8],...
                'Units','normalized',...
                'Position', textpos);              
  end

end