function y = applyLUT(x,grid_in,grid_out,type)
  if ~exist('type','var')
    type = 'linear';
  end

  switch type
    case 'linear'
      S = getLinearInterpolationMatrix(x,grid_in);
    case 'cubic'
        S = getCubicInterpolationMatrix(x,grid_in);
    case 'spline'
        S = getBSplineInterpolationMatrix(x,grid_in);      
    otherwise
      error('unknown interpolation type');
  end

  y = (grid_out*S);


