function Y2 = latticeRegression(X1,Y1,X2,beta)
  time.start = clock;
  X1 = X1';
  Y1 = Y1';
  X2 = X2';
  
  %collect some information
  [ d, nX] = size(X1); [dY, nY] = size(Y1);
  if (nY ~= nX), error('X1 Y1 length mismatch'); end 
  
  [dG, nG] = size(X2);
  if (dG ~= d), error('X1 X2 dimension mismatch'); end 
  nGrid = getGrid(X2);
      
  %Interp Matrix from grid points to data    
  S = getLinearInterpolationMatrix(X1,X2);
  
  K = graphHessian(nGrid);
  K = K + 1e-6*speye(size(K));  
  
  LHS = (1/nX * (S*S')  + beta * K);
  RHS = (1/nX * S*Y1');
  
  Y2 = (LHS\RHS)';
    
  time.elap = etime(clock,time.start);
  %fprintf('lattice regression took %1.3fs\n',time.elap);  
end